From 246c12cc9689697e4dc86c3c226119bc3797e953 Mon Sep 17 00:00:00 2001
From: Arina Neshlyaeva <arina.neshlyaeva@intel.com>
Date: Tue, 6 Sep 2022 15:53:16 -0700
Subject: [PATCH] Use AddressInfo in Symbol class

---
 src/sym.cpp |  3 ++-
 src/sym.h   | 10 ++++++++--
 2 files changed, 10 insertions(+), 3 deletions(-)

diff --git a/src/sym.cpp b/src/sym.cpp
index f6f87ed17..c14284741 100644
--- a/src/sym.cpp
+++ b/src/sym.cpp
@@ -1,5 +1,5 @@
 /*
-  Copyright (c) 2010-2021, Intel Corporation
+  Copyright (c) 2010-2022, Intel Corporation
   All rights reserved.
 
   Redistribution and use in source and binary forms, with or without
@@ -50,6 +50,7 @@ using namespace ispc;
 
 Symbol::Symbol(const std::string &n, SourcePos p, const Type *t, StorageClass sc) : pos(p), name(n) {
     storagePtr = NULL;
+    storageInfo = NULL;
     function = exportedFunction = NULL;
     type = t;
     constValue = NULL;
diff --git a/src/sym.h b/src/sym.h
index d02a37d25..b8ffc719a 100644
--- a/src/sym.h
+++ b/src/sym.h
@@ -1,5 +1,5 @@
 /*
-  Copyright (c) 2010-2021, Intel Corporation
+  Copyright (c) 2010-2022, Intel Corporation
   All rights reserved.
 
   Redistribution and use in source and binary forms, with or without
@@ -39,6 +39,7 @@
 
 #pragma once
 
+#include "ctx.h"
 #include "decl.h"
 #include "ispc.h"
 #include <map>
@@ -72,7 +73,12 @@ class Symbol {
     llvm::Value *storagePtr;  /*!< For symbols with storage associated with
                                    them (i.e. variables but not functions),
                                    this member stores a pointer to its
-                                   location in memory.) */
+                                   location in memory.)
+                                   DEPRECATED. Use storageInfo instead. */
+    AddressInfo *storageInfo; /*!< For symbols with storage associated with
+                                   them (i.e. variables but not functions),
+                                   this member stores an address info: pointer to
+                                   its location in memory and its element type.) */
     llvm::Function *function; /*!< For symbols that represent functions,
                                    this stores the LLVM Function value for
                                    the symbol once it has been created. */
